/*
** Copyright (C) 2001,2002 Sacha Faust <sacha@severus.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
package faust.sacha.web.util;

import java.util.*;
import java.net.*;
/**
 * @author Sacha Faust
 * @version <PRE>1.4 - dev</PRE>
 */
public class DomainInfo {
    
    private String m_domain;
    private int m_nbDomain;
    Vector m_subDomainList;
    
    public DomainInfo( String domain ) throws UnknownHostException {
        /*
         *  Making sure we have a domain
         */
        m_domain = InetAddress.getAllByName(domain)[0].getHostName();
        m_subDomainList = new Vector(0);
        init();
    }
//------------------------------------------------------------------------------
    private void init() throws UnknownHostException {
        StringTokenizer domainTokens = new StringTokenizer(m_domain, ".");        
        String strToken = null;
        
        m_nbDomain = domainTokens.countTokens();
        if( m_nbDomain < 2 )
            throw new UnknownHostException(m_domain);
        
        while( domainTokens.hasMoreTokens() ){
            strToken = domainTokens.nextToken();
            m_subDomainList.add( (Object)strToken );
        }
    }
//------------------------------------------------------------------------------
    public String toString(){
        return m_domain;
    }
//------------------------------------------------------------------------------
    public int getNbSubDomain(){
        return m_nbDomain;
    }
//------------------------------------------------------------------------------
    public String getDomainStruct( int nbSubdomain ){
        String domainRet = new String();
        int intSubDomain = nbSubdomain;
        
        if( nbSubdomain < 0 )
            return null;
        
        if( (nbSubdomain -1) > m_subDomainList.size() )
            return null;
        
        for( int i = m_subDomainList.size()-1; intSubDomain > 0; intSubDomain--, i-- ){
            if( i == m_subDomainList.size()-1 )
                domainRet = (String)m_subDomainList.get(i);
            else
                domainRet = (String)m_subDomainList.get(i) + "." + domainRet;
        }
        
        return domainRet;
    }    
//------------------------------------------------------------------------------
    public static void main( String args[] ){
        DomainInfo d = null;
        
        try{
            d = new DomainInfo("www.cerias.purdue.edu");
        }
        catch( UnknownHostException u ){
            System.err.println(u);
        }
        
        System.err.println( d.getNbSubDomain() );
        System.err.println( d.getDomainStruct(d.getNbSubDomain()) );
    }
//------------------------------------------------------------------------------    
    
}
