/*
** Copyright (C) 2001,2002 Sacha Faust <sacha@severus.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
package org.ideahamster.metis.stat;

import org.ideahamster.metis.util.MetisGlobal;
import faust.sacha.web.data.*;
import faust.sacha.web.util.*;
import java.util.*;

/**
 * @author Sacha Faust
 * @version <PRE>1.4</PRE>
 */
public class SiteUsers {
    
    private Site m_site;
    private Hashtable m_userList;
    private EmailByDomainStat m_emails;
    
    public SiteUsers( Site site, EmailByDomainStat emails ) {
        m_site = site;
        m_userList = new Hashtable(0);
        m_emails = emails;
        
        init();
    }
//------------------------------------------------------------------------------
    protected void init() {
        Vector foundInFolders = null;
        Vector foundInEmails = null;
        Enumeration folderList = null;
        EmailURL tmpEmail = null;
        String tmpFolder = null;
        String tmpUser = null;
        int pos = -1;
        ArrayList siteEmailList = null;
        String emailDomain = null;
        ElementStat elementStat = null;
        
        foundInFolders = new Vector(0);
        foundInEmails = new Vector(0);
        m_userList.put( (Object)"folders", (Object)foundInFolders );
        m_userList.put( (Object)"emails", (Object)foundInEmails );
        
        elementStat = m_emails.getElement(m_site.getEmailDomain());
        if( elementStat == null )
            return;
        
        siteEmailList = elementStat.getMembers();
        
        if( siteEmailList == null )
            return;
        
        // looking in emails
        for( int i = 0; i < siteEmailList.size(); i++ ){
            tmpEmail = (EmailURL)siteEmailList.get(i);
            if( !userPresent(tmpEmail.getUser(), foundInEmails) )
                foundInEmails.add( (Object)tmpEmail.getUser() );            
        }
        
        // looking in folders
        folderList = m_site.getFoldersNames();
        while( folderList.hasMoreElements() ){
            tmpFolder = (String)folderList.nextElement();
            /*
             *  we are looking for users in /~user/...
             */
            if( tmpFolder.toLowerCase().startsWith("/~") ){
                // find the index of the next / if 1 exist
                pos = tmpFolder.indexOf("/",2);     // 2 == starting after /~
                if( pos == -1 ){     // no more /
                    tmpUser = tmpFolder.substring(2, tmpFolder.length());
                }
                else{
                    tmpUser = tmpFolder.substring(2, pos);
                }
            
                if( !userPresent(tmpUser, foundInFolders) )
                    foundInFolders.add( (Object)tmpUser );
            }
        }
    }
//------------------------------------------------------------------------------
    private boolean userPresent( String user, Vector list ){
        String tmpStr = null;
        
        for( int i = 0; i < list.size(); i++ ){
            tmpStr = (String)list.get(i);
            if( tmpStr.equalsIgnoreCase(user) )
                return true;
        }
        
        return false;
    }
//------------------------------------------------------------------------------    
    public Enumeration getUserListKeys(){
        return m_userList.keys();
    }
//------------------------------------------------------------------------------
    public Vector getUserList( String key ){
        return (Vector)m_userList.get( (Object)key );
    }
//------------------------------------------------------------------------------    
}
